//|------------------------------------------------------------------+
//|																													 SOM_ex5 |
//|												 Copyright 2011, MetaQuotes Software Corp. |
//|															 								 http://www.mql5.com |
//|------------------------------------------------------------------+
#property copyright "Copyright 2011, MetaQuotes Software Corp."
#property link		"http://www.mql5.com"
#property version	"1.00"

#property script_show_inputs

#include "SOM.mqh"
#import "shell32.dll"
   int ShellExecuteW(int hwnd, string oper, string prog, string param, string dir, int show);
#import

input string DataFileName="OptimizationReport.csv"; //   
input int CellsX=45; //    X
input int CellsY=45; //    Y
input int ImageW=780; //  
input int ImageH=600; //  
input int MaxPictures=4; // .   
input bool HexagonalCell=true; //    
input bool ShowBorders=false; //   
input bool ShowTitles=true; //     
input ColorSchemes ColorScheme=Blue_Green_Red; //  
input bool ShowProgress=false; //      (  )
input bool OpenAfterAnaliz=true; //      

//------------------------------------------------------------------	OnStart
void OnStart()
{
	CSOM KohonenMap;
	MathSrand(200);
	//     
	if(!KohonenMap.LoadTrainData(DataFileName)) { Print("    "); return; }
	KohonenMap.Init(10000, CellsX, CellsY, ImageW, ImageH, MaxPictures, ColorScheme, HexagonalCell, ShowBorders, ShowTitles); //  
	KohonenMap.Train(ShowProgress); //  
	KohonenMap.Render(); //    
	KohonenMap.ShowTrainPatterns(); //          
	KohonenMap.ShowBMP(); //    
	if (OpenAfterAnaliz) 
		ShellExecuteW(0, "open", "explorer.exe", TerminalInfoString(TERMINAL_PATH)+"\\MQL5\\Files", TerminalInfoString(TERMINAL_PATH)+"\\MQL5\\Files", 1);
}